import datetime
import json
import jsonschema  # type: ignore
import requests

from collections.abc import Callable
from typing import Any, Iterable, Optional, TypeVar

from algorithm_utilities.arise.dsi.algorithm.utilities.analysis_data_classes import (
    ImageBoundingBox,
    JsonAlgorithmAnalysisResults,
    JsonMedia,
    JsonPrediction,
    JsonRegion,
    JsonRegionGroup,
    JsonTaxa,
    JsonTaxaItem,
    MediaDataItem,
    Prediction,
    SoundFragment,
)


"""
    These classes were created to tackle the following problems:

    1. Algorithm developers need to use documentation to use our schema when setting up
       the output for their AI algorithms. The classes below will report issues earlier
       and makes it easier for them to create analysis results in the format that we can
       handle.
    2. Make it easier for us to read the analysis results generated by an algorithm
       and we have more confidence that the fields have the correct type and exist if
       needed.
    3. Both the algorithm template and the ARISE DSI system need certain functionality. These classes support both and
       ensure consistency & reusability.

    These classes are WIP and will probably change. They will eventually replace `/dsi_common/interpreted_result.py`.

    Schema V1 based on:
    - https://gitlab.com/arise-biodiversity/schemas/-/blob/main/
    V1_schema_dsi_predictions.json?ref_type=heads
        Changes:
        - Added "schema_version" and "name" types.
        - Made "predictions[]"->"taxa" required.
        - Made "probability" and "name" for "predictions[]"->"taxa" required.
          todo: There was also a required "id" field added, which is now not required.
"""

# todo: We should not have multiple copies of the schema. If we think the schema needs to change, we should discuss that
#       with the team and create new versions when needed.


class AnalysisResultException(Exception):
    def __init__(self, message: str):
        self.message = message


class AnalysisResultValidator:
    def __init__(self):
        self._json = None

    def validate(self, analysis_result_json: dict[str, Any]):
        self._json = analysis_result_json

        if self._json:
            self._validate_analysis_result_json()
            self._validate_referential_integrity()
            self._validate_dimensions()

    def _validate_analysis_result_json(self):
        version = self._json.get("schema_version", "V1")

        if version != "V1":
            raise AnalysisResultException(f"JSON schema version '{version}' is not supported.")
        
        expected_schema_name = "https://schemas.arise-biodiversity.nl/dsi/multi-object-multi-image#sequence-one-prediction-per-region"
        schema_name = self._json.get("name", expected_schema_name)

        if schema_name != expected_schema_name:
            raise AnalysisResultException(
                f"JSON schema name '{schema_name}' is not the expected schema '{expected_schema_name}'."
            )

        base_arise_url = "https://gitlab.com/arise-biodiversity"
        json_schema_url = f"{base_arise_url}/schemas/-/raw/algo_schema_v1.0.1/schema_dsi_predictions.json"
        json_schema = json.loads(requests.get(json_schema_url).text)

        try:
            jsonschema.validate(self._json, json_schema)

        except jsonschema.exceptions.ValidationError as error:
            raise AnalysisResultException(error.message) from error

    def _validate_referential_integrity(self):
        """Referential integrity

        - Does every prediction -> region group ID match a region group -> ID?
        - Does every region group -> region -> media ID match a media item ID?
        - Are there any region group ID or media item ID un-referred-to? If so, print a warning (not an error).
        """
        region_group_ids = set([region_group["id"] for region_group in self._json["region_groups"]])
        predictions_region_group_ids = set([prediction["region_group_id"] for prediction in self._json["predictions"]])

        self._check_for_mismatches(
            optional_ids=region_group_ids,
            required_ids=predictions_region_group_ids,
            optional_description="region_groups[]->id",
            required_description="predictions[]->region_group_id",
        )

        media_ids = set([media_item["id"] for media_item in self._json["media"]])
        region_media_ids = set([region["media_id"] for region_group in self._json["region_groups"] for region in region_group["regions"]])

        self._check_for_mismatches(
            optional_ids=media_ids,
            required_ids=region_media_ids,
            optional_description="media[]->id",
            required_description="region_groups[]->regions[]->media_id",
        )

    def _check_for_mismatches(
        self,
        optional_ids: set[str],
        required_ids: set[str],
        optional_description: str,
        required_description: str,
    ):
        mismatches = optional_ids.difference(required_ids)

        if len(mismatches) > 0:
            print(f"Warning: Found {len(mismatches)} {optional_description} not used.")

        mismatches = required_ids.difference(optional_ids)

        if len(mismatches) > 0:
            for mismatch in mismatches:
                print(mismatch)

            raise AnalysisResultException(f"Error: Found {len(mismatches)} {required_description} without a corresponding {optional_description}.")

    def _validate_dimensions(self):
        """
        Dimensions expressions.

        - Does every region_groups[]->regions[]->box contain field groups x1/y1/x2/y2 OR t1/t2? Error if not.
          (If there is no box, no problem; if there is a box but there are no field groups, this is an error.)
        - Does every x1/y1/t1 have a matching x2/y2/t2? Error if not.
        - Does every pair x1/x2 y1/y2 t1/t2 have an "<=" relationship? Error if not.
        - Does every x1 have a matching y1? Error if not.
          Note that it's fine to have no box at all. This is equivalent to a prediction for the entire media item
          (image/sound/etc.).
        """
        for region_group in self._json["region_groups"]:
            for region in region_group["regions"]:
                if "box" in region:
                    region_box = region["box"]

                    has_spatial_dimensions = False
                    has_temporal_dimensions = False

                    # for x and y
                    if all(key in region_box for key in ["x1", "x2", "y1", "y2"]):
                        has_spatial_dimensions = True
                        x1 = region_box["x1"]
                        x2 = region_box["x2"]
                        y1 = region_box["y1"]
                        y2 = region_box["y2"]

                        if x1 > x2:
                            print(region)
                            raise AnalysisResultException("Error: region box has 'x1' greater than 'x2'.")
                        if y1 > y2:
                            print(region)
                            raise AnalysisResultException("Error: region box has 'y1' greater than 'y2'.")

                        for coord in [x1, x2, y1, y2]:
                            if not isinstance(coord, float) or not (0 <= coord <= 1):
                                raise AnalysisResultException(
                                    f"Error: Box coordinates must be a float between 0 and 1. Found invalid value '{coord}' in region box '{region_box}'."
                                )
                    elif any(key in region_box for key in ["x1", "x2", "y1", "y2"]):
                        print(region)
                        raise AnalysisResultException("Error: Incomplete spatial dimensions in region box.")

                    # for t 
                    if "t1" in region_box and "t2" in region_box:
                        has_temporal_dimensions = True
                        t1 = region_box["t1"]
                        t2 = region_box["t2"]

                        if t1 > t2:
                            print(region)
                            raise AnalysisResultException("Error: region box has 't1' greater than 't2'.")

                        for timevalue in [t1, t2]:
                            if not isinstance(timevalue, float):
                                raise AnalysisResultException(
                                    f"Error: Type of t1 or t2 was not float. Found invalid value '{timevalue}' in region box '{region_box}'."
                                )
                    elif "t1" in region_box or "t2" in region_box:
                        print(region)
                        raise AnalysisResultException("Error: Incomplete temporal dimensions in region box.")

                    # to ensure at least one type of dimension is present
                    if not (has_spatial_dimensions or has_temporal_dimensions):
                        print(region)
                        message = "Error: region has a box but it contains neither spatial '(x1, y1)' nor temporal '(t1)' extents."
                        raise AnalysisResultException(message)



class AnalysisResultParser:
    def parse(self, analysis_result_json: dict[str, Any], validate: Optional[bool] = True) -> JsonAlgorithmAnalysisResults:
        if not analysis_result_json:
            return JsonAlgorithmAnalysisResults([], [], [])

        if validate:
            AnalysisResultValidator().validate(analysis_result_json)

        media_items = analysis_result_json.get("media", [])
        predictions = analysis_result_json.get("predictions", [])
        region_groups = analysis_result_json.get("region_groups", [])

        parsed_media = []
        for media in media_items:
            media_item_id = media.get("id")
            file_name = media.get("filename")

            parsed_media.append(JsonMedia(media_item_id, file_name))

        parsed_predictions = []
        for prediction in predictions:
            region_group_id = prediction.get("region_group_id")
            taxa = prediction.get("taxa")
            taxa_type = taxa.get("type")
            taxa_items = taxa.get("items")

            parsed_taxa_items = []
            for taxa_item in taxa_items:
                taxa_item_id = taxa_item.get("id")
                name = taxa_item.get("name")
                probability_json = taxa_item.get("probability")

                try:
                    probability = float(probability_json)

                except TypeError:
                    raise AnalysisResultException(
                        f"Provided probability '{probability_json}' of object "
                        f"'{taxa_item}' within predictions/taxa/items array is not "
                        f"convertable to a float."
                    )

                parsed_taxa_items.append(JsonTaxaItem(taxa_item_id, name, probability))

            parsed_predictions.append(
                JsonPrediction(
                    region_group_id,
                    JsonTaxa(taxa_type=taxa_type, taxa_items=parsed_taxa_items),
                )
            )

        coordinate_names_bounding_box = {"x1", "y1", "x2", "y2"}
        coordinate_names_sound_fragment = {"t1", "t2"}

        parsed_region_groups = []
        for region_group in region_groups:
            region_group_id = region_group.get("id")
            individual_id = region_group.get("individual_id")
            regions = region_group.get("regions")

            parsed_regions: list[JsonRegion] = []
            for region in regions:
                media_id = str(region.get("media_id"))
                box = region.get("box")

                self._append_region(
                    parsed_regions,
                    media_id,
                    box,
                    coordinate_names_bounding_box,
                    "image bounding box",
                )
                self._append_region(
                    parsed_regions,
                    media_id,
                    box,
                    coordinate_names_sound_fragment,
                    "sound fragment",
                )

            parsed_region_groups.append(JsonRegionGroup(region_group_id, individual_id, parsed_regions))

        return JsonAlgorithmAnalysisResults(parsed_media, parsed_region_groups, parsed_predictions)

    def _append_region(
        self,
        parsed_regions: list[JsonRegion],
        media_id: str,
        box: dict[str, Any],
        coordinate_names: set[str],
        description: str,
    ) -> None:
        image = len(coordinate_names) == 4
        coordinate_count = len(coordinate_names.intersection(box.keys()))
        if coordinate_count == len(coordinate_names):
            x1 = str_to_float(box.get("x1"))
            y1 = str_to_float(box.get("y1"))
            x2 = str_to_float(box.get("x2"))
            y2 = str_to_float(box.get("y2"))

            t1 = str_to_float(box.get("t1"))
            t2 = str_to_float(box.get("t2"))

            if (image and None not in [x1, y1, x2, y2]) or (not image and None not in [t1, t2]):
                region_box = ImageBoundingBox(x1, y1, x2, y2) if image else SoundFragment(t1, t2)
                parsed_regions.append(JsonRegion(media_id, region_box))
            else:
                raise AnalysisResultException(f"One or more coordinates for an {description} of dictionary '{box}' are not convertable to a float.")
        elif coordinate_count > 0:
            raise AnalysisResultException(f"Not all coordinates for an {description} were found in dictionary '{box}'.")


class AnalysisResultFilter:
    # todo: This could also be a method of the JsonAlgorithmAnalysisResults class.
    def filter_predictions_by_media(self, analysis_results: JsonAlgorithmAnalysisResults, media_item_id: str) -> list[Prediction]:

        if not first(
            analysis_results.json_media_list,
            lambda media: media.media_item_id == media_item_id,
        ):
            raise AnalysisResultException(f"No matching media item ID '{media_item_id}'.")

        predictions = []
        for json_prediction in analysis_results.json_predictions:
            region_group_id = json_prediction.region_group_id
            region_group = first(
                analysis_results.json_region_groups,
                lambda group: group.region_group_id == region_group_id,
            )

            if not region_group:
                raise AnalysisResultException(f"Missing matching 'region_group' for ID '{json_prediction.region_group_id}'.")

            region = first(
                region_group.regions,
                lambda group_region: group_region.media_id == media_item_id,
            )

            # todo: Discuss with Jonty, this region can be skipped, no exception?
            if region:
                # raise AnalysisResultException(
                #     f"Missing matching 'region' for region_group_id "
                #     f"'{json_prediction.region_group_id}'"
                #     f" and media item ID '{media_item_id}'."
                # )

                for taxa_item in json_prediction.taxa.taxa_items:
                    predictions.append(Prediction(taxa_item.name, taxa_item.probability, region.box))

        return predictions


class AnalysisResultBuilder:
    def create_analysis_results(
        self,
        algorithm_prefix: str,
        algorithm_version: str,
        media_data_items: list[MediaDataItem],
    ) -> dict[str, Any]:
        # Create the skeleton for the analysis results JSON using the ARISE output
        # format.
        analysis_results = self.create_analysis_results_skeleton(
            algorithm_prefix,
            algorithm_version,
        )

        # Handle the analysis results.
        for media_data_item in media_data_items:
            # Add the filename and the media ID.
            analysis_results["media"].append({"filename": media_data_item.filename, "id": media_data_item.media_id})

            per_media_item_region_counter = 0

            for prediction in media_data_item.predictions:
                self.add_prediction(
                    analysis_results,
                    prediction,
                    media_data_item.media_id,
                    per_media_item_region_counter,
                )

                per_media_item_region_counter += 1

        return analysis_results

    def create_analysis_results_skeleton(
        self,
        algorithm_prefix: str,
        algorithm_version: str,
    ) -> dict[str, Any]:
        return {
            # todo: Is this different for bird recognition (audio vs image)?
            "name": "https://schemas.arise-biodiversity.nl/dsi/" "multi-object-multi-image#sequence-one-prediction-per-region",
            # todo: There is no public URL with the schema yet - this is the best we
            #       currently have:
            #       https://gitlab.com/arise-biodiversity/schemas/-/raw/main/
            #       schema_dsi_predictions.json
            "generated_by": {
                "datetime": datetime.datetime.now().isoformat() + "Z",
                "version": algorithm_version,
                "tag": algorithm_prefix,
            },
            "media": [],
            "region_groups": [],
            "predictions": [],
        }

    def add_prediction(
        self,
        analysis_results: dict[str, Any],
        prediction: Prediction,
        media_id: str,
        per_media_item_region_counter: int,
    ) -> None:
        region_id = f"{media_id}?region={per_media_item_region_counter}"

        if isinstance(prediction.segment, ImageBoundingBox):
            region_box = {
                "x1": prediction.segment.x1,
                "y1": prediction.segment.y1,
                "x2": prediction.segment.x2,
                "y2": prediction.segment.y2,
            }
        elif isinstance(prediction.segment, SoundFragment):
            region_box = {
                "t1": prediction.segment.t1,
                "t2": prediction.segment.t2,
            }
        else:
            raise TypeError(f"Unsupported prediction segment '{prediction.segment}'.")

        analysis_results["region_groups"].append(
            {
                "id": region_id,
                # Because individuals are not tracked (yet), we re-use the region_id
                # as individual_id.
                "individual_id": region_id,
                "regions": [
                    {
                        "box": region_box,
                        "media_id": media_id,
                    },
                ],
            }
        )

        scientific_name_id = f"LITERAL:{prediction.name.upper()}"
        probability = round(float(prediction.probability), 6)

        analysis_results["predictions"].append(
            {
                "region_group_id": region_id,
                "taxa": {
                    "type": "multiclass",
                    "items": [
                        {
                            "name": prediction.name,
                            "probability": probability,
                            "scientific_name_id": scientific_name_id,
                        }
                    ],
                },
            }
        )


def str_to_float(text: Optional[Any], default_value: Optional[float] = None) -> Optional[float]:
    try:
        return float(str(text))

    except (ValueError, TypeError):
        return default_value


T = TypeVar("T")


def first(
    iterable: Iterable[T],
    condition: Optional[Callable[[T], bool]] = None,
    default: Optional[T] = None,
) -> Optional[T]:
    filter_function = condition if condition else lambda _: True
    return next(filter(filter_function, iterable), default)
